#include <iostream>
using namespace std;

#define MAX 50

int empilhar(int v[], int &topo, int valor);
int desempilhar(int v[], int &topo, int &valor);

int main(void) {
    // Declara as pilhas
    int num[MAX];
    int tnum = -1;
    int oper[MAX];
    int toper = -1;
    // Contador
    int i;
    // Variaveis para clculo
    int a, b, c, op;

    // Expresso
    char exp[MAX];
    // Cada dado da expressao
    int dado;

    // L uma linha de texto
    cout << "Digite uma expressao na notacao infixa:" << endl;
    cin.getline(exp, MAX);

    // Para dada elemento da linha...
    for(i=0; exp[i]!='\0'; i++) {
        // Pega elemento
        dado = exp[i];
        // Se for um dgito
        if (isdigit(dado)) {
            // Corrige o valor (converte de valor ASCII para valor inteiro)
            dado = dado - '0';
            // Empilha na pilha de nmeros
            empilhar(num,tnum,dado);
        }
        else {
            switch(dado) {
                // Se for algum dos operadores, simplesmente empilha
                case '+':
                case '*':
                    empilhar(oper,toper,dado);
                    break;
                // Se for fecha parnteses, realiza o clculo
                case ')':
                    // Desempilha valores
                    desempilhar(num, tnum, a);
                    desempilhar(num, tnum, b);
                    desempilhar(oper, toper, op);
                    if (op == '+') c = a + b;
                    else if (op == '*') c = a * b;
                    empilhar(num, tnum, c);
                    break;
                // Valores ignorados
                case ' ':
                case '(':
                    break;
                default:
                    cout << "ERRO: Expressao invalida!" << endl;
                    return 1;
            }
        }
    }
    desempilhar(num,tnum, c);
    cout << "Resultado: " << c << endl;
}

// Empilha um valor
// Entrada:
//  v: vetor com elementos da pilha
//  topo: topo da pilha
//  valor: valor a ser empilhado
// Retorna:
//  1- Se pilha cheia
//  0- Caso contrrio
int empilhar(int v[], int &topo, int valor) {
    // Se a pilha est cheia... retorna 1
    if (topo>=MAX-1) {
        cout << "ERRO: Pilha cheia!" << endl;
        return 1;
    }
    // Se pilha no est cheia, vamos empilhar
    topo = topo + 1;
    v[topo] = valor;
    // Indica que valor foi empilhado
    return 0;
}


// Desempilha um valor
// Entrada:
//  v: vetor com elementos da pilha
//  topo: topo da pilha
//  valor: Local a colocar valor desempilhado
// Retorna:
//  valor: valor desempilhado
//  1- Se pilha vazia
//  0- Caso contrrio
int desempilhar(int v[], int &topo, int &valor) {
    // Se a pilha est vazia... retorna 1
    if (topo<0) {
        cout << "ERRO: Pilha vazia!" << endl;
        return 1;
    }
    // Se pilha no est vazia, vamos desempilhar
    valor = v[topo];
    topo = topo - 1;
    // Indica que valor foi desempilhado
    return 0;
}


